每日一题day1(Leetcode 76最小覆盖子串)

1.题目解析

1.该题"讲人话"就是在一个字符串s中找到一个最短的能够涵盖子串所有字符的子串

2.解法

  1. 解法1(暴力枚举+hash表)
cpp 复制代码
class Solution {
public:
    string minWindow(string s, string t) {
        int m = s.size();
        int n = t.size();
        if (m < n)
            return "";                 // 解决实例3的特殊情况
        unordered_map<char, int> need; // 统计t中的字符需要的次数
        for (auto c : t) {
            need[c]++;
        }
        int required = need.size(); // 记录字符种类
        int len = INT_MAX;
        int start = 0; // 记录子串开始位置为后续返回字符串奠定基础
        for (int i = 0; i < m; i++) {
            int matched = 0;
            unordered_map<char, int> window;
            for (int j = i; j < m; j++) {
                char c = s[j];
                if (need.count(c)) { // 筛除不必要的元素
                    window[c]++;     // 记录子串中字符出现次数
                    if (window[c] == need[c])
                        matched++; // 达到目标
                }
                if (matched == required) {
                    int currentlen = j - i + 1;

                    if (currentlen < len) {
                        len = currentlen;
                        start = i; // 更新位置
                    }
                    break;
                }
            }
        }
        return len == INT_MAX ? "" : s.substr(start, len);
    }
};

虽然这种解题方法容易想但是作为一道困难题是绝对不可能让你暴力(O(n^2))过的,这个时候我们就需要在暴力的基础上进行优化
我们此处可以选择使用滑动窗口的方式对该问题进行优化

  1. 解法2(滑动窗口+手动hash)
cpp 复制代码
class Solution {
public:
    string minWindow(string s, string t) {

        int hash1[128] = {0}; // 统计t内字符出现的次数
        int kinds = 0;//统计有效字符个数
        for (auto ch : t) {
            if (hash1[ch]++ == 0)
                kinds++;
        }

        int hash2[128] = {0};
        int minlen = INT_MAX, begin = -1;
        for (int left = 0, right = 0, count = 0; right < s.size(); right++) {
            char in = s[right];
            if (++hash2[in] == hash1[in])//进窗口加维护count
                count++;
            while (count == kinds) {//判断
                if (right - left + 1 < minlen) {//更新结果
                    minlen = right - left + 1;
                    begin = left;
                }
                char out = s[left++];//出·窗口维护count
                if (hash2[out]-- == hash1[out])
                    count--;
            }
        }
        if (begin == -1)
            return "";
        else
            return s.substr(begin, minlen);
    }
};
相关推荐
HZY1618yzh几秒前
下一代编程语言出炉
c++·算法
CoderYanger8 分钟前
A.每日一题:856. 括号的分数
java·程序人生·算法·leetcode·面试·职场和发展·学习方法
kiracrimson21 分钟前
选择排序与快速排序:一次选极值,一次分区间
算法·排序算法
All for pursuit.41 分钟前
【动态规划-8】152.乘积最大子数组
数据结构·c++·算法·leetcode·动态规划
信奥卷王43 分钟前
[GESP202512 六级] 路径覆盖
数据结构·算法
Lazionr1 小时前
手撕 unordered_set 和 unordered_map,剖析哈希表底层实现
c++·算法
0+1111 小时前
算法 --归并排序
数据结构·算法·排序算法
Run_Teenage1 小时前
算法:树的重心、树的直径
算法
专注仿真1 小时前
高代价计算后置:探测、交战、毁伤三条链路的统一设计哲学
算法·探测·毁伤
xie0510_1 小时前
Any类简要实现
开发语言·c++·算法